import _ from 'lodash';

export type ValueEnumItem = { [key: string]: any };
export type ValueEnum = ValueEnumItem[] | Record<string | number, string>;
export type OptionItem = {
  text: string;
  value: string | number;
  [key: string]: any;
};

export function convertOptions(
  valueEnum: ValueEnum,
  enumLabelKey: string,
  enumValueKey: string
): OptionItem[] {
  return _.isArray(valueEnum)
    ? valueEnum.map((x) => ({
        ...x,
        text: x[enumLabelKey],
        value: _.isNaN(Number(x[enumValueKey])) ? x[enumValueKey] : Number(x[enumValueKey]),
      }))
    : Object.keys(valueEnum).map((x) => ({
        value: _.isNaN(Number(x)) ? x : Number(x),
        text: valueEnum[x],
      }));
}

export type ChooseCheckBoxOptionItem = {
  text: string;
  value: string | number;
};
